<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for NotificationSeverityType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Identifies the set of severity values for a Notification.
 * @subpackage Enumerations
 */
class NotificationSeverityType extends AbstractStructEnumBase
{
    /**
     * Constant for value 'ERROR'
     * @return string 'ERROR'
     */
    const VALUE_ERROR = 'ERROR';
    /**
     * Constant for value 'FAILURE'
     * @return string 'FAILURE'
     */
    const VALUE_FAILURE = 'FAILURE';
    /**
     * Constant for value 'NOTE'
     * @return string 'NOTE'
     */
    const VALUE_NOTE = 'NOTE';
    /**
     * Constant for value 'SUCCESS'
     * @return string 'SUCCESS'
     */
    const VALUE_SUCCESS = 'SUCCESS';
    /**
     * Constant for value 'WARNING'
     * @return string 'WARNING'
     */
    const VALUE_WARNING = 'WARNING';
    /**
     * Return allowed values
     * @uses self::VALUE_ERROR
     * @uses self::VALUE_FAILURE
     * @uses self::VALUE_NOTE
     * @uses self::VALUE_SUCCESS
     * @uses self::VALUE_WARNING
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_ERROR,
            self::VALUE_FAILURE,
            self::VALUE_NOTE,
            self::VALUE_SUCCESS,
            self::VALUE_WARNING,
        );
    }
}
